#!groovy

def version=1.2
def app="test-apps"
def workingdir="${app}/testapp"
def gitURL="https://gitlab.com/jim.haughey1990/test-apps/"
def mvnHome


node {
    stage('clear previous pull'){
        echo "clearing previous pull"
            sh "rm -rf ${app}"
    }

    stage('pulling code') {

        echo "pulling code from ${gitURL} ..."
        sh "git clone ${gitURL}"
        mvnHome = tool 'M3'
    }

    stage('test') {
        echo 'Beginning to test ...'
        dir ("${workingdir}"){
            sh "${mvnHome}/bin/mvn clean test"
            junit 'target/surefire-reports/*.xml'
            sh "${mvnHome}/bin/mvn surefire-report:report"
            publishHTML([allowMissing: false, alwaysLinkToLastBuild: false, keepAll: false, reportDir: 'target/site/', reportFiles: 'surefire-report.html', reportName: 'Unit Test Results Report', reportTitles: 'Unit Test Results Report'])
        }
    }

    stage('code coverage') {
        dir ("${workingdir}"){
            jacoco execPattern: 'target/jacoco.exec'
        }
    }

    stage('build') {
        echo 'Beginning to build ...'
        dir ("${workingdir}"){
            sh "${mvnHome}/bin/mvn clean package -Dmaven.test.skip=true"
        }
    }

    stage('push to cf'){
        dir ("${workingdir}"){
            pushToCloudFoundry(
                target: 'api.ng.bluemix.net',
                organization: 'Agile Pilot Project',
                cloudSpace: 'DevOps',
                credentialsId: 'test-cred1',
                pluginTimeout: "300",
                 manifestChoice: [
                    manifestFile: 'manifest.yml'
                ]
            )
        }
    }

}